<?php
/**
 * @package     VikBooking
 * @subpackage  com_vikbooking
 * @author      Alessio Gaggii - e4j - Extensionsforjoomla.com
 * @copyright   Copyright (C) 2018 e4j - Extensionsforjoomla.com. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 * @link        https://vikwp.com
 */

defined('ABSPATH') or die('No script kiddies please!');

$vbo_app = new VboApplication();
/**
 * @wponly - cannot load iFrame with FancyBox, so we use the BS's Modal
 */
if (function_exists('wp_enqueue_code_editor')) {
	// WP >= 4.9.0
	wp_enqueue_code_editor(array('type' => 'php'));
}
$vbo_app->getJmodalScript();
echo $vbo_app->getJmodalHtml('vbo-tplfiles', JText::_('VBOCONFIGEDITTMPLFILE'));
//
$editor = JEditor::getInstance(JFactory::getApplication()->get('editor'));
$document = JFactory::getDocument();
$document->addStyleSheet(VBO_SITE_URI.'resources/jquery.fancybox.css');
$document->addStyleSheet(VBO_ADMIN_URI.'resources/js_upload/colorpicker.css');
JHtml::_('script', VBO_SITE_URI.'resources/jquery.fancybox.js', false, true, false, false);
JHtml::_('script', VBO_ADMIN_URI.'resources/js_upload/colorpicker.js', false, true, false, false);
JHtml::_('script', VBO_ADMIN_URI.'resources/js_upload/eye.js', false, true, false, false);
JHtml::_('script', VBO_ADMIN_URI.'resources/js_upload/utils.js', false, true, false, false);

$themesel = '<select name="theme">';
$themesel .= '<option value="default">default</option>';
$themes = glob(VBO_SITE_PATH.DS.'themes'.DS.'*');
$acttheme = VikBooking::getTheme();
if (count($themes) > 0) {
	$strip = VBO_SITE_PATH.DS.'themes'.DS;
	foreach ($themes as $th) {
		if (is_dir($th)) {
			$tname = str_replace($strip, '', $th);
			if ($tname != 'default') {
				$themesel .= '<option value="'.$tname.'"'.($tname == $acttheme ? ' selected="selected"' : '').'>'.$tname.'</option>';
			}
		}
	}
}
$themesel .= '</select>';
$firstwday = VikBooking::getFirstWeekDay(true);
?>
<div class="vbo-config-maintab-left">
	<fieldset class="adminform">
		<div class="vbo-params-wrap">
			<legend class="adminlegend"><?php echo JText::_('VBOCPARAMLAYOUT'); ?></legend>
			<div class="vbo-params-container">
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGFIRSTWDAY'); ?></div>
					<div class="vbo-param-setting"><select name="firstwday"><option value="0"<?php echo $firstwday == '0' ? ' selected="selected"' : ''; ?>><?php echo JText::_('VBSUNDAY'); ?></option><option value="1"<?php echo $firstwday == '1' ? ' selected="selected"' : ''; ?>><?php echo JText::_('VBMONDAY'); ?></option><option value="2"<?php echo $firstwday == '2' ? ' selected="selected"' : ''; ?>><?php echo JText::_('VBTUESDAY'); ?></option><option value="3"<?php echo $firstwday == '3' ? ' selected="selected"' : ''; ?>><?php echo JText::_('VBWEDNESDAY'); ?></option><option value="4"<?php echo $firstwday == '4' ? ' selected="selected"' : ''; ?>><?php echo JText::_('VBTHURSDAY'); ?></option><option value="5"<?php echo $firstwday == '5' ? ' selected="selected"' : ''; ?>><?php echo JText::_('VBFRIDAY'); ?></option><option value="6"<?php echo $firstwday == '6' ? ' selected="selected"' : ''; ?>><?php echo JText::_('VBSATURDAY'); ?></option></select></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGTHREETEN'); ?></div>
					<div class="vbo-param-setting"><input type="number" name="numcalendars" value="<?php echo VikBooking::numCalendars(); ?>" min="0" max="24"/></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBOCONFIGTHUMBSIZE'); ?></div>
					<div class="vbo-param-setting"><input type="number" name="thumbsize" value="<?php echo VikBooking::getThumbSize(true); ?>" min="20" max="1000"/></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGTHREENINE'); ?></div>
					<div class="vbo-param-setting"><?php echo $vbo_app->printYesNoButtons('showpartlyreserved', JText::_('VBYES'), JText::_('VBNO'), (VikBooking::showPartlyReserved() ? 'yes' : 0), 'yes', 0); ?></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGTHREECHECKINOUTSTAT'); ?></div>
					<div class="vbo-param-setting"><?php echo $vbo_app->printYesNoButtons('showcheckinoutonly', JText::_('VBYES'), JText::_('VBNO'), (VikBooking::showStatusCheckinoutOnly() ? 1 : 0), 1, 0); ?></div>
				</div>

				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBOCONFIGEMAILTEMPLATE'); ?></div>
					<div class="vbo-param-setting">
						<div class="btn-wrapper input-append">
							<button type="button" class="btn vbo-edit-tmpl" data-tmpl-path="<?php echo urlencode(VBO_SITE_PATH.DS.'helpers'.DS.'email_tmpl.php'); ?>"><i class="icon-edit"></i> <?php echo JText::_('VBOCONFIGEDITTMPLFILE'); ?></button>
							<button type="button" class="btn vbo-edit-tmpl vbo-preview-btn" title="<?php echo addslashes(JText::_('VBOPREVIEW')); ?>" data-prew-path="<?php echo urlencode(VBO_SITE_PATH.DS.'helpers'.DS.'email_tmpl.php'); ?>"><?php VikBookingIcons::e('eye'); ?></button>
						</div>
					</div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBOCONFIGINVOICETEMPLATE'); ?></div>
					<div class="vbo-param-setting"><button type="button" class="btn vbo-edit-tmpl" data-tmpl-path="<?php echo urlencode(VBO_SITE_PATH.DS.'helpers'.DS.'invoices'.DS.'invoice_tmpl.php'); ?>"><i class="icon-edit"></i> <?php echo JText::_('VBOCONFIGEDITTMPLFILE'); ?></button></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBOMANUALINVOICE'); ?></div>
					<div class="vbo-param-setting"><button type="button" class="btn vbo-edit-tmpl" data-tmpl-path="<?php echo urlencode(VBO_SITE_PATH.DS.'helpers'.DS.'invoices'.DS.'custom_invoice_tmpl.php'); ?>"><i class="icon-edit"></i> <?php echo JText::_('VBOCONFIGEDITTMPLFILE'); ?></button></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBOCONFIGCHECKINTEMPLATE'); ?></div>
					<div class="vbo-param-setting"><button type="button" class="btn vbo-edit-tmpl" data-tmpl-path="<?php echo urlencode(VBO_SITE_PATH.DS.'helpers'.DS.'checkins'.DS.'checkin_tmpl.php'); ?>"><i class="icon-edit"></i> <?php echo JText::_('VBOCONFIGEDITTMPLFILE'); ?></button></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBOCONFIGCUSTCSSTPL'); ?></div>
					<!-- @wponly  the path of the file is different in WP, it's inside /resources -->
					<div class="vbo-param-setting"><button type="button" class="btn vbo-edit-tmpl" data-tmpl-path="<?php echo urlencode(VBO_SITE_PATH.DS.'resources'.DS.'vikbooking_custom.css'); ?>"><i class="icon-edit"></i> <?php echo JText::_('VBOCONFIGEDITTMPLFILE'); ?></button></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBOCONFIGCUSTBACKCSSTPL'); ?></div>
					<div class="vbo-param-setting"><button type="button" class="btn vbo-edit-tmpl" data-tmpl-path="<?php echo urlencode(VBO_ADMIN_PATH.DS.'resources'.DS.'vikbooking_backendcustom.css'); ?>"><i class="icon-edit"></i> <?php echo JText::_('VBOCONFIGEDITTMPLFILE'); ?></button></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGTHREESIX'); ?></div>
					<div class="vbo-param-setting"><?php echo $vbo_app->printYesNoButtons('showfooter', JText::_('VBYES'), JText::_('VBNO'), (VikBooking::showFooter() ? 'yes' : 0), 'yes', 0); ?></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGTHEME'); ?></div>
					<div class="vbo-param-setting"><?php echo $themesel; ?></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGTHREESEVEN'); ?></div>
					<div class="vbo-param-setting"><?php echo $editor->display( "intromain", VikBooking::getIntroMain(), '100%', 350, 70, 20 ); ?></div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_('VBCONFIGTHREEEIGHT'); ?></div>
					<div class="vbo-param-setting"><textarea name="closingmain" rows="5" cols="60" style="min-width: 400px;"><?php echo htmlspecialchars(VikBooking::getClosingMain()); ?></textarea></div>
				</div>
			</div>
		</div>
	</fieldset>
</div>

<div class="vbo-config-maintab-right">
<?php
$colortags = VikBooking::loadBookingsColorTags();
$tagsrules = VikBooking::loadColorTagsRules();
$opt_js_rules = '';
foreach ($tagsrules as $tagk => $tagv) {
	$opt_js_rules .= '<option value=\"'.$tagk.'\">'.addslashes(JText::_($tagv)).'</option>';
}
?>
	<fieldset class="adminform">
		<div class="vbo-params-wrap">
			<legend class="adminlegend"><?php echo JText::_('VBOCPARAMBOOKTAGS'); ?></legend>
			<div class="vbo-params-container">
			<?php
			foreach ($colortags as $ctagk => $ctagv) {
				?>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><?php echo JText::_($ctagv['name']); ?></div>
					<div class="vbo-param-setting">
						<div class="vbo-colortag-square" style="background-color: <?php echo $ctagv['color']; ?>; color: <?php echo VikBooking::getBestColorContrast($ctagv['color']); ?>;"><i class="vboicn-price-tags"></i></div>
						<input type="hidden" name="bctagname[]" class="bctagname" value="<?php echo $ctagv['name']; ?>" />
						<input type="hidden" name="bctagcolor[]" class="bctagcolor" value="<?php echo $ctagv['color']; ?>" />
						<select name="bctagrule[]" style="margin: 0; vertical-align: top;">
						<?php
						foreach ($tagsrules as $tagk => $tagv) {
							?>
							<option value="<?php echo $tagk; ?>"<?php echo !empty($tagk) && $tagk == $ctagv['rule'] ? ' selected="selected"' : ''; ?>><?php echo JText::_($tagv); ?></option>
							<?php
						}
						?>
						</select>
						<div style="float: right;"><button class="btn btn-danger vbo-colortag-rm" type="button">X</button></div>
					</div>
				</div>
				<?php
			}
			?>
				<div class="vbo-param-container" id="vbo-colortag-lasttr">
					<div class="vbo-param-label"><button class="btn vbo-colortag-add" type="button"><i class="icon-new"></i> <?php echo JText::_('VBOCOLORTAGADD'); ?></button></div>
					<div class="vbo-param-setting"> </div>
				</div>
				<div class="vbo-param-container">
					<div class="vbo-param-label"><a class="btn btn-danger" href="index.php?option=com_vikbooking&amp;task=config&amp;reset_tags=1" onclick="return confirm('<?php echo addslashes(JText::_('VBDELCONFIRM')); ?>');"><i class="icon-remove"></i> <?php echo JText::_('VBOCOLORTAGRMALL'); ?></a></div>
					<div class="vbo-param-setting"> </div>
				</div>
			</div>
		</a>
	</fieldset>
</div>

<script type="text/javascript">
var vboHexDigits = new Array ("0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f");
function vboRgb2Hex(rgb) {
	rgb = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
	return "#" + vboHex(rgb[1]) + vboHex(rgb[2]) + vboHex(rgb[3]);
}
function vboHex(x) {
	return isNaN(x) ? "00" : vboHexDigits[(x - x % 16) / 16] + vboHexDigits[x % 16];
}
jQuery(document).ready(function() {
	jQuery(".vbo-edit-tmpl").click(function() {
		var vbo_tmpl_path = jQuery(this).attr("data-tmpl-path");
		var vbo_prew_path = jQuery(this).attr("data-prew-path");
		if (!vbo_tmpl_path && !vbo_prew_path) {
			return;
		}
		var basetask = !vbo_tmpl_path ? 'tmplfileprew' : 'edittmplfile';
		var basepath = !vbo_tmpl_path ? vbo_prew_path : vbo_tmpl_path;
		// @wponly - we use the BS's Modal to open the template files editing page
		vboOpenJModal('vbo-tplfiles', "index.php?option=com_vikbooking&task=" + basetask + "&path=" + basepath + "&tmpl=component");
	});
	jQuery(".vbo-colortag-add").click(function() {
		jQuery("#vbo-colortag-lasttr").before(
			"<div class=\"vbo-param-container\">"+
			"<div class=\"vbo-param-label\"> <input type=\"text\" name=\"bctagname[]\" class=\"bctagname\" value=\"\" placeholder=\"<?php echo addslashes(JText::_('VBOCOLORTAGADDPLCHLD')); ?>\" size=\"25\" /> </div>"+
			"<div class=\"vbo-param-setting\">"+
			"<div class=\"vbo-colortag-square\" style=\"\"><i class=\"vboicn-price-tags\"></i></div>"+
			"<input type=\"hidden\" name=\"bctagcolor[]\" class=\"bctagcolor\" value=\"#ffffff\" />"+
			"<select name=\"bctagrule[]\" style=\"margin: 0; vertical-align: top;\"><?php echo $opt_js_rules; ?></select>"+
			"<div style=\"float: right;\"><button class=\"btn btn-danger vbo-colortag-rm\" type=\"button\">X</button></div>"+
			"</div>"+
			"</div>"
		);
		jQuery('.vbo-colortag-square').ColorPicker({
			color: '#ffffff',
			onShow: function (colpkr, el) {
				var cur_color = jQuery(el).css('backgroundColor');
				jQuery(el).ColorPickerSetColor(vboRgb2Hex(cur_color));
				jQuery(colpkr).show();
				return false;
			},
			onChange: function (hsb, hex, rgb, el) {
				jQuery(el).css('backgroundColor', '#'+hex);
				jQuery(el).parent().find('.bctagcolor').val('#'+hex);
			},
			onSubmit: function(hsb, hex, rgb, el) {
				jQuery(el).css('backgroundColor', '#'+hex);
				jQuery(el).parent().find('.bctagcolor').val('#'+hex);
				jQuery(el).ColorPickerHide();
			},
		});
	});
	jQuery(document.body).on('click', '.vbo-colortag-rm', function() {
		jQuery(this).closest('tr').remove();
	});
	jQuery('.vbo-colortag-square').ColorPicker({
		color: '#ffffff',
		onShow: function (colpkr, el) {
			var cur_color = jQuery(el).css('backgroundColor');
			jQuery(el).ColorPickerSetColor(vboRgb2Hex(cur_color));
			jQuery(colpkr).show();
			return false;
		},
		onChange: function (hsb, hex, rgb, el) {
			jQuery(el).css('backgroundColor', '#'+hex);
			jQuery(el).parent().find('.bctagcolor').val('#'+hex);
		},
		onSubmit: function(hsb, hex, rgb, el) {
			jQuery(el).css('backgroundColor', '#'+hex);
			jQuery(el).parent().find('.bctagcolor').val('#'+hex);
			jQuery(el).ColorPickerHide();
		},
	});
});
</script>
