<?php
/**
 * @package     VikBooking
 * @subpackage  com_vikbooking
 * @author      Alessio Gaggii - e4j - Extensionsforjoomla.com
 * @copyright   Copyright (C) 2018 e4j - Extensionsforjoomla.com. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 * @link        https://vikwp.com
 */

defined('ABSPATH') or die('No script kiddies please!');

// import Joomla view library
jimport('joomla.application.component.view');

class VikBookingViewEditorder extends JViewVikBooking {
	
	function display($tpl = null) {
		// Set the toolbar
		$this->addToolBar();

		$cid = VikRequest::getVar('cid', array(0));
		$ido = $cid[0];
		if (is_file(VCM_ADMIN_PATH.DIRECTORY_SEPARATOR.'assets'.DIRECTORY_SEPARATOR.'css'.DIRECTORY_SEPARATOR.'vcm-channels.css')) {
			$document = JFactory::getDocument();
			$document->addStyleSheet(VCM_ADMIN_URI.'assets/css/vikchannelmanager.css');
			$document->addStyleSheet(VCM_ADMIN_URI.'assets/css/vcm-channels.css');
		}
		$dbo = JFactory::getDbo();
		$user = JFactory::getUser();
		$q = "SELECT * FROM `#__vikbooking_orders` WHERE `id`=".$dbo->quote($ido).";";
		$dbo->setQuery($q);
		$dbo->execute();
		if ($dbo->getNumRows() != 1) {
			$mainframe = JFactory::getApplication();
			$mainframe->redirect("index.php?option=com_vikbooking&task=orders");
			exit;
		}
		$row = $dbo->loadAssoc();
		$q = "SELECT `id`,`name` FROM `#__vikbooking_gpayments` ORDER BY `#__vikbooking_gpayments`.`name` ASC;";
		$dbo->setQuery($q);
		$dbo->execute();
		$payments = $dbo->getNumRows() > 0 ? $dbo->loadAssocList() : '';
		$cpin = VikBooking::getCPinIstance();
		// VBO 1.11 - change customer assigned to this booking
		$pnewcustid = VikRequest::getInt('newcustid', 0, 'request');
		if (!empty($pnewcustid)) {
			$cpin->updateCustomerBooking($row['id'], $pnewcustid);
			// update empty values for the booking
			if (empty($row['custmail']) || empty($row['phone'])) {
				// get customer information
				$customer = $cpin->getCustomerByID($pnewcustid);
				if (count($customer) && (!empty($customer['email']) || !empty($customer['phone']))) {
					if (empty($row['custmail']) && !empty($customer['email'])) {
						$q = "UPDATE `#__vikbooking_orders` SET `custmail`=" . $dbo->quote($customer['email']) . " WHERE `id`=" . $row['id'] . ";";
						$dbo->setQuery($q);
						$dbo->execute();
						$row['custmail'] = $customer['email'];
					}
					if (empty($row['phone']) && !empty($customer['phone'])) {
						$q = "UPDATE `#__vikbooking_orders` SET `phone`=" . $dbo->quote($customer['phone']) . " WHERE `id`=" . $row['id'] . ";";
						$dbo->setQuery($q);
						$dbo->execute();
						$row['phone'] = $customer['phone'];
					}
				}
			}
			//
		}
		//
		$customer = $cpin->getCustomerFromBooking($row['id']);
		if (count($customer) && !empty($customer['country'])) {
			if (file_exists(VBO_ADMIN_PATH.DIRECTORY_SEPARATOR.'resources'.DIRECTORY_SEPARATOR.'countries'.DIRECTORY_SEPARATOR.$customer['country'].'.png')) {
				$customer['country_img'] = '<img src="'.VBO_ADMIN_URI.'resources/countries/'.$customer['country'].'.png'.'" title="'.$customer['country'].'" class="vbo-country-flag vbo-country-flag-left"/>';
			}
		}
		$padminnotes = VikRequest::getString('adminnotes', '', 'request');
		$pupdadmnotes = VikRequest::getString('updadmnotes', '', 'request');
		$pinvnotes = VikRequest::getString('invnotes', '', 'request', VIKREQUEST_ALLOWHTML);
		$pupdinvnotes = VikRequest::getString('updinvnotes', '', 'request');
		$pnewpayment = VikRequest::getString('newpayment', '', 'request');
		$pnewlang = VikRequest::getString('newlang', '', 'request');
		$padmindisc = VikRequest::getString('admindisc', '', 'request');
		$ptot_taxes = VikRequest::getString('tot_taxes', '', 'request');
		$ptot_city_taxes = VikRequest::getString('tot_city_taxes', '', 'request');
		$ptot_fees = VikRequest::getString('tot_fees', '', 'request');
		$pcmms = VikRequest::getString('cmms', '', 'request');
		$pcustmail = VikRequest::getString('custmail', '', 'request');
		$pcustphone = VikRequest::getString('custphone', '', 'request');
		$pmakepay = VikRequest::getInt('makepay', '', 'request');
		$pnewamountpaid = VikRequest::getFloat('newamountpaid', 0, 'request');
		$pnewamountpaymeth = VikRequest::getString('newamountpaymeth', '', 'request');
		if ($pnewamountpaid > 0 && (float)$row['totpaid'] != $pnewamountpaid) {
			$prevpaid = (float)$row['totpaid'];
			$q = "UPDATE `#__vikbooking_orders` SET `totpaid`=".$dbo->quote($pnewamountpaid)." WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['totpaid'] = $pnewamountpaid;
			// Booking History log for new amount paid (payment update)
			$extra_data = null;
			$newpaympaytype = '';
			if ($pnewamountpaid > $prevpaid) {
				$extra_data = new stdClass;
				$extra_data->amount_paid = ($pnewamountpaid - $prevpaid);
				if (!empty($pnewamountpaymeth)) {
					$payparts = explode('_', $pnewamountpaymeth);
					$newpaympaytype = count($payparts) > 1 ? $payparts[1] : $pnewamountpaymeth;
					$extra_data->payment_method = $newpaympaytype;
				}
			}
			VikBooking::getBookingHistoryInstance()->setBid($row['id'])->setExtraData($extra_data)->store('PU', JText::sprintf('VBOPREVAMOUNTPAID', VikBooking::numberFormat($prevpaid) . (!empty($newpaympaytype) ? ' ('.$newpaympaytype.')' : '')));
			//
		}
		if ($pmakepay > 0) {
			$q = "UPDATE `#__vikbooking_orders` SET `paymcount`=1 WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['paymcount'] = 1;
		}
		if (!empty($padminnotes) || !empty($pupdadmnotes)) {
			$q = "UPDATE `#__vikbooking_orders` SET `adminnotes`=".$dbo->quote($padminnotes)." WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['adminnotes'] = $padminnotes;
		}
		if (!empty($pinvnotes) || !empty($pupdinvnotes)) {
			$pinvnotes = strpos($pinvnotes, '<br') !== false ? $pinvnotes : nl2br($pinvnotes);
			$q = "UPDATE `#__vikbooking_orders` SET `inv_notes`=".$dbo->quote($pinvnotes)." WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['inv_notes'] = $pinvnotes;
		}
		if (!empty($pnewpayment) && is_array($payments)) {
			foreach ($payments as $npay) {
				if ((int)$npay['id'] == (int)$pnewpayment) {
					$newpayvalid = $npay['id'].'='.$npay['name'];
					$q = "UPDATE `#__vikbooking_orders` SET `idpayment`=".$dbo->quote($newpayvalid)." WHERE `id`=".$row['id'].";";
					$dbo->setQuery($q);
					$dbo->execute();
					$row['idpayment'] = $newpayvalid;
					break;
				}
			}
		}
		if (!empty($pnewlang)) {
			$q = "UPDATE `#__vikbooking_orders` SET `lang`=".$dbo->quote($pnewlang)." WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['lang'] = $pnewlang;
		}
		if (strlen($padmindisc) > 0) {
			if (floatval($padmindisc) > 0.00) {
				$admincoupon = '-1;'.floatval($padmindisc).';'.JText::_('VBADMINDISCOUNT');
			} else {
				$admincoupon = '';
			}
			$expcoupon = explode(";", $row['coupon']);
			// make sure the new discount is different than the previous one, and that the total amount is greater than zero
			if ($row['total'] > 0 && (empty($row['coupon']) || (float)$expcoupon[1] != (float)$padmindisc)) {
				// re-calculate new total by adding the previous discount and by subtracting the new one
				$newtotal = $row['total'] + (!empty($row['coupon']) ? (float)$expcoupon[1] : 0);
				$newtotal -= (float)$padmindisc;
				//
				$q = "UPDATE `#__vikbooking_orders` SET `coupon`=" . $dbo->quote($admincoupon) . ", `total`=" . $dbo->quote($newtotal) . " WHERE `id`={$row['id']};";
				$dbo->setQuery($q);
				$dbo->execute();
				$row['coupon'] = $admincoupon;
				$row['total'] = $newtotal;
			}
		}
		if (strlen($ptot_taxes) > 0) {
			$q = "UPDATE `#__vikbooking_orders` SET `tot_taxes`='".floatval($ptot_taxes)."' WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['tot_taxes'] = $ptot_taxes;
		}
		if (strlen($ptot_city_taxes) > 0) {
			$q = "UPDATE `#__vikbooking_orders` SET `tot_city_taxes`='".floatval($ptot_city_taxes)."' WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['tot_city_taxes'] = $ptot_city_taxes;
		}
		if (strlen($ptot_fees) > 0) {
			$q = "UPDATE `#__vikbooking_orders` SET `tot_fees`='".floatval($ptot_fees)."' WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['tot_fees'] = $ptot_fees;
		}
		if (strlen($pcmms) > 0) {
			$q = "UPDATE `#__vikbooking_orders` SET `cmms`='".floatval($pcmms)."' WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['cmms'] = $pcmms;
		}
		if (strlen($pcustmail) > 0) {
			$q = "UPDATE `#__vikbooking_orders` SET `custmail`=".$dbo->quote($pcustmail)." WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['custmail'] = $pcustmail;
		}
		if (strlen($pcustphone) > 0) {
			$q = "UPDATE `#__vikbooking_orders` SET `phone`=".$dbo->quote($pcustphone)." WHERE `id`=".$row['id'].";";
			$dbo->setQuery($q);
			$dbo->execute();
			$row['phone'] = $pcustphone;
		}

		// load data
		$q = "SELECT `or`.*,`r`.`name`,`r`.`fromadult`,`r`.`toadult`,`r`.`params` FROM `#__vikbooking_ordersrooms` AS `or`,`#__vikbooking_rooms` AS `r` WHERE `or`.`idorder`=".(int)$row['id']." AND `or`.`idroom`=`r`.`id` ORDER BY `or`.`id` ASC;";
		$dbo->setQuery($q);
		$dbo->execute();
		$rooms = $dbo->getNumRows() ? $dbo->loadAssocList() : array();
		$q = "SELECT * FROM `#__vikbooking_ordersbusy` WHERE `idorder`=".(int)$row['id'].";";
		$dbo->setQuery($q);
		$dbo->execute();
		$busy = $dbo->getNumRows() ? $dbo->loadAssocList() : "";

		// Rooms Specific Unit
		$proomindex = VikRequest::getVar('roomindex', array());
		if (!empty($proomindex) && is_array($proomindex) && count($proomindex)) {
			$orig_rooms = $rooms;
			foreach ($proomindex as $or_id => $rind) {
				if (empty($or_id)) {
					continue;
				}
				$q = "UPDATE `#__vikbooking_ordersrooms` SET `roomindex`=".(!empty($rind) ? (int)$rind : "NULL")." WHERE `id`=".(int)$or_id." AND `idorder`=".(int)$row['id'].";";
				$dbo->setQuery($q);
				$dbo->execute();
				// update global array reference
				foreach ($rooms as $korr => $orr) {
					if ((int)$or_id == (int)$orr['id']) {
						$rooms[$korr]['roomindex'] = $rind;
						break;
					}
				}
				// try to store a booking history record when switching room sub-unit index
				if (!empty($rind)) {
					foreach ($orig_rooms as $korr => $orr) {
						if ((int)$or_id != (int)$orr['id']) {
							continue;
						}
						if (empty($orr['params'])) {
							continue;
						}
						$room_params = json_decode($orr['params'], true);
						if (is_array($room_params) && isset($room_params['features']) && @count($room_params['features'])) {
							$prev_subindex = empty($orr['roomindex']) ? '---' : $orr['roomindex'];
							$new_subindex  = $rind;
							foreach ($room_params['features'] as $origrind => $rfeatures) {
								if ($orr['roomindex'] == $origrind) {
									foreach ($rfeatures as $fname => $fval) {
										if (strlen($fval)) {
											$prev_subindex = '#' . $origrind . ' - ' . JText::_($fname) . ': ' . $fval;
											break;
										}
									}
								}
								if ($rind == $origrind) {
									foreach ($rfeatures as $fname => $fval) {
										if (strlen($fval)) {
											$new_subindex = '#' . $origrind . ' - ' . JText::_($fname) . ': ' . $fval;
											break;
										}
									}
								}
							}
							//Booking History
							VikBooking::getBookingHistoryInstance()->setBid($row['id'])->store('MB', "({$user->name}) " . JText::sprintf('VBOROOMSUBUNITCHANGEFT', $orr['name'], $prev_subindex, $new_subindex));
							//
						}
					}
				}
				//
			}
		}

		// PCI DSS Checking
		if (!empty($row['idorderota']) && !empty($row['channel']) && !empty($row['paymentlog'])) {
			if (stripos($row['paymentlog'], 'card number') !== false && strpos($row['paymentlog'], '*') !== false) {
				$checkout_info = getdate($row['checkout']);
				/**
				 * Limit for accessing the credit card details has been changed to check-out
				 * day at 23:59:59 + 10 extra days. It used to be at 23:59:59 on check-out day.
				 * 
				 * @since 	1.13
				 */
				$cardlimit = mktime(23, 59, 59, $checkout_info['mon'], ($checkout_info['mday'] + 10), $checkout_info['year']);
				if (time() > $cardlimit) {
					$newlogstr = JText::_('VBOCCLOGDATAREMOVEDPCIDSS');
					$q = "UPDATE `#__vikbooking_orders` SET `paymentlog`=".$dbo->quote($newlogstr)." WHERE `id`=".$row['id'].";";
					$dbo->setQuery($q);
					$dbo->execute();
					$row['paymentlog'] = $newlogstr;
				}
			}
		}

		// attempt to get the VCM review ID with a try-catch to avoid SQL errors
		$vcm_review = array();
		try {
			if (is_file(VCM_SITE_PATH . DIRECTORY_SEPARATOR . 'helpers' . DIRECTORY_SEPARATOR . 'lib.vikchannelmanager.php')) {
				$q = "SELECT * FROM `#__vikchannelmanager_otareviews` WHERE `idorder`=".$row['id'].";";
				$dbo->setQuery($q);
				$dbo->execute();
				if ($dbo->getNumRows()) {
					$vcm_review = $dbo->loadAssoc();
				}
			}
		} catch (Exception $e) {
			// do nothing as VCM is probably not available
		}
				
		$this->row = &$row;
		$this->rooms = &$rooms;
		$this->busy = &$busy;
		$this->customer = &$customer;
		$this->payments = &$payments;
		$this->vcm_review = &$vcm_review;
		
		// Display the template
		parent::display($tpl);
	}

	/**
	 * Sets the toolbar
	 */
	protected function addToolBar() {
		$printreceipt = VikRequest::getInt('print', 0, 'request');
		if ($printreceipt) {
			// do not print any header or buttons if we are printing the receipt
			return;
		}

		JToolBarHelper::title(JText::_('VBMAINORDERTITLEEDIT'), 'vikbooking');
		JToolBarHelper::cancel( 'canceledorder', JText::_('VBBACK'));
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'prev_booking', 'backward', 'backward', JText::_('VBJQCALPREV'), false);
		JToolBarHelper::spacer();
		JToolBarHelper::custom( 'next_booking', 'forward', 'forward', JText::_('VBJQCALNEXT'), false);
		JToolBarHelper::spacer();
	}

}
