<?php
/**
 * @package     VikBooking
 * @subpackage  com_vikbooking
 * @author      Alessio Gaggii - e4j - Extensionsforjoomla.com
 * @copyright   Copyright (C) 2018 e4j - Extensionsforjoomla.com. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 * @link        https://vikwp.com
 */

defined('ABSPATH') or die('No script kiddies please!');

$document = JFactory::getDocument();
// load jQuery lib e jQuery UI
if (VikBooking::loadJquery()) {
	// JHtml::_('jquery.framework', true, true);
	JHtml::_('script', VBO_SITE_URI.'resources/jquery-1.12.4.min.js', false, true, false, false);
}
$document->addStyleSheet(VBO_SITE_URI.'resources/jquery-ui.min.css');
JHtml::_('script', VBO_SITE_URI.'resources/jquery-ui.min.js', false, true, false, false);

$currencysymb = VikBooking::getCurrencySymb();
$datesep = VikBooking::getDateSeparator();
$nowdf = VikBooking::getDateFormat();
if ($nowdf == "%d/%m/%Y") {
	$df = 'd/m/Y';
	$juidf = 'dd/mm/yy';
} elseif ($nowdf == "%m/%d/%Y") {
	$df = 'm/d/Y';
	$juidf = 'mm/dd/yy';
} else {
	$df = 'Y/m/d';
	$juidf = 'yy/mm/dd';
}
$wdays_map 	= array(
	JText::_('VBWEEKDAYZERO'),
	JText::_('VBWEEKDAYONE'),
	JText::_('VBWEEKDAYTWO'),
	JText::_('VBWEEKDAYTHREE'),
	JText::_('VBWEEKDAYFOUR'),
	JText::_('VBWEEKDAYFIVE'),
	JText::_('VBWEEKDAYSIX')
);
$ts_info = getdate($this->order['ts']);
$checkin_info = getdate($this->order['checkin']);
$checkout_info = getdate($this->order['checkout']);
$pitemid = VikRequest::getInt('Itemid', 0, 'request');

// compose the calculation for pax_data
list($pax_fields, $pax_fields_attributes) = VikBooking::getPaxFields(true);
$pax_data = array();
$count_pax_data = 1;
if (!empty($this->customer['pax_data'])) {
	$pax_data = json_decode($this->customer['pax_data'], true);
}

$arrpeople = array();
foreach ($this->orderrooms as $ind => $or) {
	$num = $ind + 1;
	$arrpeople[$num]['adults'] = $or['adults'];
	$arrpeople[$num]['children'] = $or['children'];
	$arrpeople[$num]['children_age'] = $or['childrenage'];
	$arrpeople[$num]['t_first_name'] = $or['t_first_name'];
	$arrpeople[$num]['t_last_name'] = $or['t_last_name'];
}

// countries list
$all_countries = VikBooking::getCountriesArray();

?>

<h3 class="vbo-booking-details-intro"><?php echo JText::sprintf('VBOYOURBOOKCONFAT', VikBooking::getFrontTitle()); ?></h3>

<div class="vbo-booking-details-topcontainer vbo-booking-details-precheckin">
	
	<div class="vbo-booking-details-head vbo-booking-details-head-confirmed">
		<h4><?php echo JText::_('VBOPRECHECKIN'); ?></h4>
	</div>

	<div class="vbo-booking-details-midcontainer">
		<div class="vbo-booking-details-bookinfos">
			<span class="vbvordudatatitle"><?php echo JText::_('VBORDERDETAILS'); ?></span>
			<div class="vbo-booking-details-bookinfo">
				<span class="vbo-booking-details-bookinfo-lbl"><?php echo JText::_('VBORDEREDON'); ?></span>
				<span class="vbo-booking-details-bookinfo-val"><?php echo $wdays_map[$ts_info['wday']].', '.date(str_replace("/", $datesep, $df).' H:i', $this->order['ts']); ?></span>
			</div>
			<div class="vbo-booking-details-bookinfo">
				<span class="vbo-booking-details-bookinfo-lbl"><?php echo JText::_('VBCONFIRMNUMB'); ?></span>
				<span class="vbo-booking-details-bookinfo-val"><?php echo $this->order['confirmnumber']; ?></span>
			</div>
			<div class="vbo-booking-details-bookinfo">
				<span class="vbo-booking-details-bookinfo-lbl"><?php echo JText::_('VBDAL'); ?></span>
				<span class="vbo-booking-details-bookinfo-val"><?php echo $wdays_map[$checkin_info['wday']].', '.date(str_replace("/", $datesep, $df).' H:i', $this->order['checkin']); ?></span>
			</div>
			<div class="vbo-booking-details-bookinfo">
				<span class="vbo-booking-details-bookinfo-lbl"><?php echo JText::_('VBAL'); ?></span>
				<span class="vbo-booking-details-bookinfo-val"><?php echo $wdays_map[$checkout_info['wday']].', '.date(str_replace("/", $datesep, $df).' H:i', $this->order['checkout']); ?></span>
			</div>
			<div class="vbo-booking-details-bookinfo">
				<span class="vbo-booking-details-bookinfo-lbl"><?php echo JText::_('VBDAYS'); ?></span>
				<span class="vbo-booking-details-bookinfo-val"><?php echo $this->order['days']; ?></span>
			</div>
		</div>
	</div>

	<div class="vbo-precheckin-container">
		<form action="<?php echo JRoute::_('index.php?option=com_vikbooking'.(!empty($pitemid) ? '&Itemid='.$pitemid : '')); ?>" method="post">
			<input type="hidden" name="option" value="com_vikbooking" />
			<input type="hidden" name="task" value="storeprecheckin" />
			<input type="hidden" name="sid" value="<?php echo empty($this->order['sid']) && !empty($this->order['idorderota']) ? $this->order['idorderota'] : $this->order['sid']; ?>" />
			<input type="hidden" name="ts" value="<?php echo $this->order['ts']; ?>" />
			<input type="hidden" name="Itemid" value="<?php echo $pitemid; ?>" />
		<?php
		foreach ($this->orderrooms as $ind => $or) {
			$num = $ind + 1;
			// total guests details available
			$count_pax_data = $num < 2 ? $count_pax_data : 0;
			if (isset($pax_data[$ind])) {
				$count_pax_data = count($pax_data[$ind]);
			}
			//
			?>
			<div class="vbo-precheckin-room-wrapper">
				<div class="vbo-precheckin-room-wrap <?php echo $count_pax_data >= $arrpeople[$num]['adults'] ? 'vbo-precheckin-guestscount-complete' : 'vbo-precheckin-guestscount-incomplete'; ?>">
					<div class="vbo-precheckin-room-head">
						<span><?php echo $or['name']; ?></span>
					</div>
					<div class="vbo-precheckin-adults-cont">
					<?php
					for ($g = 1; $g <= $arrpeople[$num]['adults']; $g++) {
						$current_guest = array();
						if (count($pax_data) && isset($pax_data[$ind]) && isset($pax_data[$ind][$g])) {
							$current_guest = $pax_data[$ind][$g];
						} elseif ($ind < 1 && $g == 1) {
							$current_guest = $this->customer;
						}
						?>
						<div class="vbo-precheckin-adult-wrap">
							<div class="vbo-precheckin-adult-num">
								<span><?php echo JText::sprintf('VBOGUESTNUM', $g); ?></span>
							</div>
						<?php
						/**
						 * Overrides tip: to add and collect custom details from each guest
						 * it is possible to push more pairs of key-values to $pax_fields.
						 * For example, a custom value could be pushed like this:
						 * 
						 * $pax_fields['custom_field_key'] = 'Custom Field Name';
						 * $pax_fields_attributes['custom_field_key'] = 'text';
						 */
						$pax_field_ind = 1;
						foreach ($pax_fields as $paxk => $paxv) {
							?>
							<div class="vbo-precheckin-guest-detail">
								<label for="pax-field-<?php echo $paxv . '-' . $ind . '-' . $g . '-' . $paxk; ?>"><?php echo $paxv; ?></label>
							<?php
							if ($pax_fields_attributes[$paxk] == 'country') {
								// field of type country
								echo VikBooking::getCountriesSelect('guests['.$ind.']['.$g.']['.$paxk.']', $all_countries, (isset($current_guest[$paxk]) ? $current_guest[$paxk] : ''), $paxv);
							} elseif ($pax_fields_attributes[$paxk] == 'calendar') {
								// datepicker
								?>
								<input type="text" autocomplete="off" data-gind="<?php echo $g; ?>" class="vbo-paxfield vbo-paxfield-datepicker" name="guests[<?php echo $ind; ?>][<?php echo $g; ?>][<?php echo $paxk; ?>]" value="<?php echo (isset($current_guest[$paxk]) ? $current_guest[$paxk] : ''); ?>" />
								<?php
							} elseif (is_array($pax_fields_attributes[$paxk])) {
								// select with multiple choices
								?>
								<select name="guests[<?php echo $ind; ?>][<?php echo $g; ?>][<?php echo $paxk; ?>]">
									<option></option>
								<?php
								foreach ($pax_fields_attributes[$paxk] as $attrk => $attrv) {
									?>
									<option value="<?php echo $attrv; ?>"<?php echo (isset($current_guest[$paxk]) && $current_guest[$paxk] == $attrv ? ' selected="selected"' : ''); ?>><?php echo $attrv; ?></option>
									<?php
								}
								?>
								</select>
								<?php
							} else {
								// text
								?>
								<input type="text" autocomplete="off" data-gind="<?php echo $g; ?>" class="vbo-paxfield" name="guests[<?php echo $ind; ?>][<?php echo $g; ?>][<?php echo $paxk; ?>]" value="<?php echo (isset($current_guest[$paxk]) ? $current_guest[$paxk] : ''); ?>" />
								<?php
							}
							?>
							</div>
							<?php
							$pax_field_ind++;
						}
						?>
						</div>
						<?php
					}
					?>
					</div>
				</div>
			</div>
			<?php
		}
		?>
			<div class="vbo-precheckin-submit">
				<button type="submit" class="btn btn-large btn-success"><?php echo JText::_('VBOSUBMITPRECHECKIN'); ?></button>
			</div>
		</form>
	</div>

</div>

<script type="text/javascript">
jQuery(document).ready(function() {
	jQuery(".vbo-paxfield-datepicker").datepicker({
		dateFormat: "<?php echo $juidf; ?>",
		changeMonth: true,
		changeYear: true,
		yearRange: "<?php echo (date('Y') - 100) . ':' . date('Y'); ?>"
	});
});
</script>
