<?php
/**
 * @package     VikBooking
 * @subpackage  com_vikbooking
 * @author      Alessio Gaggii - e4j - Extensionsforjoomla.com
 * @copyright   Copyright (C) 2018 e4j - Extensionsforjoomla.com. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 * @link        https://vikwp.com
 */

defined('ABSPATH') or die('No script kiddies please!');

$vat_included = VikBooking::ivaInclusa();
$tax_summary = !$vat_included && VikBooking::showTaxOnSummaryOnly() ? true : false;

$currencysymb = VikBooking::getCurrencySymb();
$pitemid = VikRequest::getInt('Itemid', '', 'request');

?>
<div class="vbo-searchresults-classic-wrap">
<?php
$writeroomnum = array();
foreach ($this->res as $indroom => $rooms) {
	foreach ($rooms as $room) {
		if ($this->roomsnum > 1 && !in_array($indroom, $writeroomnum)) {
			$writeroomnum[] = $indroom;
			?>
			<div id="vbpositionroom<?php echo $indroom; ?>"></div>
			<div class="vbsearchproominfo">
				<span class="vbsearchnroom"><?php echo JText::_('VBSEARCHROOMNUM'); ?> <?php echo $indroom; ?></span>
				<span class="vbsearchroomparty"><?php VikBookingIcons::e('users'); ?> <?php echo $this->arrpeople[$indroom]['adults']; ?> <?php echo ($this->arrpeople[$indroom]['adults'] == 1 ? JText::_('VBSEARCHRESADULT') : JText::_('VBSEARCHRESADULTS')); ?> <?php echo ($this->showchildren && $this->arrpeople[$indroom]['children'] > 0 ? ", ".$this->arrpeople[$indroom]['children']." ".($this->arrpeople[$indroom]['children'] == 1 ? JText::_('VBSEARCHRESCHILD') : JText::_('VBSEARCHRESCHILDREN')) : ""); ?></span>
			</div>
			<?php
		}
		//set a different class to the main div in case the rooms usage is for less people than the capacity
		$rdiffusage = array_key_exists('diffusage', $room[0]) && $this->arrpeople[$indroom]['adults'] < $room[0]['toadult'] ? true : false;
		$has_promotion = array_key_exists('promotion', $room[0]) ? true : false;
		$maindivclass = $rdiffusage ? "room_resultdiffusage" : "room_result";
		$carats = VikBooking::getRoomCaratOriz($room[0]['idcarat'], $this->vbo_tn);
		/**
		 * @wponly 	we try to parse any shortcode inside the short description of the room
		 */
		$room[0]['smalldesc'] = do_shortcode($room[0]['smalldesc']);
		//
		$saylastavail = false;
		$showlastavail = (int)VikBooking::getRoomParam('lastavail', $room[0]['params']);
		if (!empty($showlastavail) && $showlastavail > 0) {
			if ($room[0]['unitsavail'] <= $showlastavail) {
				$saylastavail = true;
			}
		}
		$searchdet_link = JRoute::_('index.php?option=com_vikbooking&view=searchdetails&roomid='.$room[0]['idroom'].'&checkin='.$this->checkin.'&checkout='.$this->checkout.'&adults='.$this->arrpeople[$indroom]['adults'].'&children='.$this->arrpeople[$indroom]['children'].'&tmpl=component'.(!empty($pitemid) ? '&Itemid='.$pitemid : ''));
		?>
		<div class="room_item <?php echo $maindivclass; ?><?php echo $has_promotion === true ? ' vbo-promotion-price' : ''; ?>" id="vbcontainer<?php echo $indroom.'_'.$room[0]['idroom']; ?>">
			<div class="vblistroomblock">
				<div class="vbimglistdiv">
					<a href="<?php echo $searchdet_link; ?>" class="vbmodalframe" target="_blank"><img class="vblistimg" alt="<?php echo $room[0]['name']; ?>" id="vbroomimg<?php echo $indroom.'_'.$room[0]['idroom']; ?>" src="<?php echo VBO_SITE_URI; ?>resources/uploads/<?php echo $room[0]['img']; ?>"/></a>
					<div class="vbmodalrdetails"><a href="<?php echo $searchdet_link; ?>" class="vbmodalframe" target="_blank"><?php VikBookingIcons::e('plus'); ?></a></div>
				</div>
				<div class="vbo-info-room">
					<div class="vbdescrlistdiv">
						<span class="vbrowcname" id="vbroomname<?php echo $indroom.'_'.$room[0]['idroom']; ?>"><?php echo $room[0]['name']; ?></span>
						<div class="vbrowcdescr"><?php echo $room[0]['smalldesc']; ?></div>
					</div>
				<?php
				if (!empty($carats)) {
					?>
					<div class="roomlist_carats">
						<?php echo $carats; ?>
					</div>
					<?php
				}
				?>
				<?php
				if ($has_promotion === true && !empty($room[0]['promotion']['promotxt'])) {
					?>
					<div class="vbo-promotion-block">
						<div class="vbo-promotion-icon"><?php VikBookingIcons::e('percentage'); ?></div>
						<div class="vbo-promotion-description">
							<?php echo $room[0]['promotion']['promotxt']; ?>
						</div>
					</div>
					<?php
				}
				?>
				</div>
			</div>
			<div class="vbcontdivtot">
				<div class="vbdivtot">
					<div class="vbdivtotinline">
						<div class="vbsrowprice">
							<div class="vbrowroomcapacity">
							<?php
							for ($i = 1; $i <= $room[0]['toadult']; $i++) {
								if ($i <= $this->arrpeople[$indroom]['adults']) {
									VikBookingIcons::e('male');
								} else {
									VikBookingIcons::e('male', 'vbo-empty-personicn');
								}
							}
							$raw_roomcost = $tax_summary ? $room[0]['cost'] : VikBooking::sayCostPlusIva($room[0]['cost'], $room[0]['idprice']);
							?>
							</div>
							<div class="vbsrowpricediv">
								<span class="room_cost">
									<span class="vbo_currency"><?php echo $currencysymb; ?></span> 
									<span class="vbo_price"><?php echo VikBooking::numberFormat($raw_roomcost); ?></span>
								</span>
						<?php
						if (isset($room[0]['promotion']) && isset($room[0]['promotion']['discount'])) {
							if ($room[0]['promotion']['discount']['pcent']) {
								/**
								 * Do not make an upper-cent operation, but rather calculate the original price proportionally:
								 * final price : (100 - discount amount) = x : 100
								 * 
								 * @since 	1.13.5
								 */
								$prev_amount = $raw_roomcost * 100 / (100 - $room[0]['promotion']['discount']['amount']);
							} else {
								$prev_amount = $raw_roomcost + $room[0]['promotion']['discount']['amount'];
							}
							if ($prev_amount > 0) {
								?>
								<div class="vbo-room-result-price-before-discount">
									<span class="room_cost">
										<span class="vbo_currency"><?php echo $currencysymb; ?></span> 
										<span class="vbo_price"><?php echo VikBooking::numberFormat($prev_amount); ?></span>
									</span>
								</div>
								<?php
								if ($room[0]['promotion']['discount']['pcent']) {
									// hide by default the DIV containing the percent of discount
									?>
								<div class="vbo-room-result-price-before-discount-percent" style="display: none;">
									<span class="room_cost">
										<span><?php echo '-' . (float)$room[0]['promotion']['discount']['amount'] . ' %'; ?></span>
									</span>
								</div>
									<?php
								}
							}
						}
						?>
							</div>
						<?php
						if ($saylastavail === true) {
							?>
							<span class="vblastavail"><?php echo JText::sprintf('VBLASTUNITSAVAIL', $room[0]['unitsavail']); ?></span>
							<?php
						}
						?>
						</div>
						<div class="vbselectordiv">
							<button type="button" id="vbselector<?php echo $indroom.'_'.$room[0]['idroom']; ?>" class="btn vbselectr-result" onclick="vbSelectRoom('<?php echo $indroom; ?>', '<?php echo $room[0]['idroom']; ?>');"><?php echo JText::_('VBSELECTR'); ?></button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<?php
	}
}
?>
</div>
